$(document).ready(function(){
    var mouseX = 0;
    var mouseY = 0;
	var showtag = true;
	var tag_id = 0;
	var recipient = "";
	var allFields = $( [] )
					.add( $('#image_type_code') )
					.add( $('#action_type_code') )
					.add( $('#activity_type_code') )
					.add( $('#prd_line_code') )
					.add( $('#prd_code') )
					.add( $('#remark') )
					.add( $('#cost') );
    var tips = $( ".validateTips" );
	
	$("#imgtag img").on( "click", function(e) {
		var imgtag = $(this).parent();
		mouseX = ( e.pageX - $(imgtag).offset().left )  - 50;
		mouseY = ( e.pageY - $(imgtag).offset().top )  - 50;
		$( '#tagit' ).remove();
		$( imgtag ).append( '<div id="tagit"><div class="box"></div><div class="name"></div></div>' );
		$( '.name' ).append( '<button type="button" class="btn btn-success btn-sm" data-toggle="modal" data-target="#tagModal" data-whatever="New Tag"><i class="glyphicon glyphicon-plus"></i><span> New Tag</span></button>' );
		$( '.name' ).append( '<button id="btnclose" type="button" class="btn btn-warning btn-sm" ><i class="glyphicon glyphicon-ban-circle"></i><span> Cancel</span></button>' );
		$( '#tagit' ).css({ top:mouseY, left:mouseX });
		$("#btnclose").on( "click", function(e) {
			$( '#tagit' ).remove();
		});
	});
	
	$( '#tagbox' ).on( 'click', '.tagview', function(e) {
 		tag_id = $(this).attr( 'id' ).replace("view_","");
		var imgtag = $("#imgtag");
		mouseX = parseInt($(this).find('.image_x').text());
		mouseY = parseInt($(this).find('.image_y').text());
		$( '#tagit' ).remove();
		$( imgtag ).append( '<div id="tagit"><div class="box"></div><div class="name"></div></div>' );
		$( '.name' ).append( '<button id="btnedit" type="button" class="btn btn-primary btn-sm" data-toggle="modal" data-target="#tagModal" data-whatever="Edit Tag"><i class="glyphicon glyphicon-edit"></i><span> Edit Tag</span></button>' );
		$( '.name' ).append( '<button id="btnremove" type="button" class="btn btn-danger btn-sm" ><i class="glyphicon glyphicon-remove"></i><span> Remove Tag</span></button>' );
		$( '.name' ).append( '<button id="btnclose" type="button" class="btn btn-warning btn-sm" ><i class="glyphicon glyphicon-ban-circle"></i><span> Cancel</span></button>' );
		$( '#tagit' ).css({ top:mouseY, left:mouseX });
		$("#btnclose").on( "click", function(e) {
			$( '#tagit' ).remove();
		});
		$("#btnremove").on( "click", function(e) {
			if (!window.confirm("Do you really want to delete?")) {
				return false;
			}
			fn_submit(tag_id,"delete");
		});
	});
	
	
	$('#tagModal').on('show.bs.modal', function (event) {
		var default_option = '<option value="">Please Select...</option>';
		var button = $(event.relatedTarget);
		recipient = button.data('whatever');
		var modal = $(this);
		modal.find('.modal-title').text(recipient);
		$('#prd_line_code').html(default_option);
		$('#prd_code').html(default_option);
		$('#action_type_code').html(default_option);
		$('#activity_type_code').html(default_option);
		allFields.parent().removeClass( "has-error" );
		tips.parent().removeClass( "alert alert-danger" );
		tips.text("");
		modal.find('.form-control').val("");
		if(recipient == "Edit Tag"){
			edittag(getURLParameter("image_id"),tag_id);
		}
	}).on('hide.bs.modal', function (event) {
		$( '#tagit' ).remove();
	}); 
		
	$('#image_type_code').change(function() {
		fn_onchange($(this).val());
	});
	
	$('#prd_line_code').change(function() {
		fn_sub_onchange($(this).val(), $('#image_type_code').val());
	});
	
	$("#btnsave").on( "click", function(e) {
		var type = "";
		if(recipient == "Edit Tag"){
			type = "update";
		}
		else{
			type = "insert";
		}
		fn_submit(tag_id,type);
	});
	
	
	$( '#tagbox' ).on( 'mouseover', '.tagview', function() {
		if(!showtag){
			$(this).css({ opacity: 1.0 });
		}
	}).on( 'mouseout', '.tagview', function() {
		if(!showtag){
			$(this).css({ opacity: 0.0 });
		}
	});
	
	
	$('#taglist').on( 'mouseover', 'tr', function() {
		id = $(this).attr("id");
		if(!showtag){
			$('#view_' + id).css({ opacity: 1.0 });
		}
	}).on( 'mouseout', 'tr', function() {
		if(!showtag){
			$('#view_' + id).css({ opacity: 0.0 });
		}
	});
	
	$("#btnshowtag").on( "click", function(e) {
		if(showtag){
			showtag = false;
			$(this).children().removeClass( "glyphicon-eye-open" ).addClass( "glyphicon-eye-close" );
			$(this).css("background-color", "#FFCECE");
			$(".tagview").css({ opacity: 0.0 });
		}
		else{
			showtag = true;
			$(this).children().removeClass( "glyphicon-eye-close" ).addClass( "glyphicon-eye-open" );
			$(this).css("background-color", "#A4F0B7");
			$(".tagview").css({ opacity: 1.0 });
		}
	});
	
	viewtag(getURLParameter("image_id"));
	
	function fn_sub_onchange(prd_line_code, image_type_code, numarg, prd_code){
		$('.form-group').append('<img class="loading" src="img/loader.gif" />');
		var ajax =	$.ajax({
						type: 'POST',
						url: 'server/php/select_sub_filter.php',
						data: {prd_line_code: prd_line_code, image_type_code: image_type_code, file_path: getURLParameter("file_path"), image_name: getURLParameter("image_name"), cust_code: getURLParameter("cust_code")},
						success: function(val) {
							var obj = jQuery.parseJSON(val);
							$('#prd_code').html(obj.prd_code);
						}
					})
					.always(function() {
						$('.loading').remove();
					});
		if(numarg > 1){
			ajax.done(function() {
				$('#prd_code').val(prd_code);
			});
		}
	}

	function fn_onchange(image_type_code,action_type_code,activity_type_code,prd_line_code,prd_code,remark,cost){
		$('.form-group').append('<img class="loading" src="img/loader.gif" />');
		var numarg = arguments.length;
		var ajax =	$.ajax({
						type: 'POST',
						url: 'server/php/select_filter.php',
						data: {image_type_code: image_type_code, file_path: getURLParameter("file_path"), image_name: getURLParameter("image_name"), cust_code: getURLParameter("cust_code")},
						success: function(val) {
							var obj = jQuery.parseJSON(val);
							$('#prd_line_code').html(obj.prd_line_code);
							if(numarg > 1){
								fn_sub_onchange(prd_line_code, image_type_code, numarg, prd_code);
							}
							else{
								fn_sub_onchange(obj.prd_line_code2, image_type_code, 1, prd_code);
							}
							$('#action_type_code').html(obj.action_type_code);
							$('#activity_type_code').html(obj.activity_type_code);
							
						}
					})
					.always(function() {
						$('.loading').remove();
					});
		if(numarg > 1){
			ajax.done(function() {
				$('#image_type_code').val(image_type_code);
				$('#action_type_code').val(action_type_code);
				$('#activity_type_code').val(activity_type_code);
				$('#prd_line_code').val(prd_line_code);
				$('#remark').val(remark);
				$('#cost').val(cost);
			});
		}
	}

    function updateTips( t ) {
      tips.text( t );
      tips.parent().addClass( "alert alert-danger" );
    }
	
    function checkLength( o, n, min, max ) {
      if ( o.val().length == max || o.val().length == min ) {
        o.parent().addClass( "has-error" );
        updateTips( "Please Select (" + n + ")" );
        return false;
      } else {
        return true;
      }
    }

    function check_onchange(o) {
		var arr = $("#taglist tbody tr").find("td:eq(0)");
		var x = "";
		$.each( arr, function( key, value ) {
			if ($(this).text() == "Before" || $(this).text() == "After"){
				x = $(this).text();
			}
		});
		  if ( x == "Before" ) {
			  if (o.val() == "A"){
				o.parent().addClass( "has-error" );
				updateTips( "Can not select "+o.val() );
				return false;
			  }
			  else{
				  return true;
			  }

		  } 
		  else if ( x == "After" ) {
			  if (o.val() == "B"){
				o.parent().addClass( "has-error" );
				updateTips( "Can not select "+o.val() );
				return false;
			  }
			  else{
				  return true;
			  }

		  } 
		  else {
			return true;
		  }
    }
	
	function fn_submit(tag_id,type){
		if(type=="delete"){
			fn_save(tag_id,type);
		}
		else{
			var valid = true;
			allFields.parent().removeClass( "has-error" );
			valid = valid && checkLength( $('#image_type_code'), "Before / After", 0, 0 ) && check_onchange($('#image_type_code'));
			valid = valid && checkLength( $('#action_type_code'), "Action Type", 0, 0 );
			valid = valid && checkLength( $('#activity_type_code'), "Activity Type", 0, 0 );
			valid = valid && checkLength( $('#prd_line_code'), "Product Line", 0, 0 );
			valid = valid && checkLength( $('#prd_code'), "Product", 0, 0 );
			if ( valid ) {
				fn_save(tag_id,type);
			}
			return valid;
		}
	}
	
	function fn_save(tag_id,type){
		$('.modal-footer').append('<br><img class="loading" src="img/loader.gif" />');
		$("#btnsave").hide();
		$.ajax({
			type: "POST", 
			url: "server/php/savetag.php", 
			data: {
				  tag_id: tag_id,
				  image_id: getURLParameter("image_id"),
				  image_type_code: $("#image_type_code").val(),
				  action_type_code: $("#action_type_code").val(),
				  activity_type_code: $("#activity_type_code").val(),
				  prd_line_code: $("#prd_line_code").val(),
				  prd_code: $("#prd_code").val(),
				  remark: $("#remark").val(),
				  cost: $("#cost").val(),
				  image_x: mouseX,
				  image_y: mouseY,
				  type: type
				  },
			success: function(val){
				if(val){
					$('#tagModal').modal('hide');
					viewtag(getURLParameter("image_id")); 
				}
				else{
					alert('unsuccessful');
				}
			}
		})
 		.always(function() {
			$('.loading').remove();
			$("#btnsave").show();
		});
 	}
	
    function viewtag( image_id )
    {	
		$('#div_loading').append('<img class="loading" src="img/loader.gif" />');
		$.post( "server/php/taglist.php" ,  {image_id : image_id, tag_id : 0}, function( data ) {
			$('#taglist tbody').html(data.lists);
			$('#tagbox').html(data.boxes);
		}, "json")
		.always(function() {
			$('.loading').remove();
		});
    }

    function edittag( image_id , tag_id)
    {
  		$.post( "server/php/taglist.php" ,  {image_id : image_id, tag_id : tag_id}, function( data ) {
			fn_onchange(data.image_type_code,data.action_type_code,data.activity_type_code,data.prd_line_code,data.prd_code,data.remark,data.cost);
		}, "json");
    }
	
	function getURLParameter(name) {
	  return decodeURIComponent((new RegExp('[?|&]' + name + '=' + '([^&;]+?)(&|#|;|$)').exec(location.search)||[,""])[1].replace(/\+/g, '%20'))||null;
	}

});